package com.unipi.talepis.springjoindemo1;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Optional;

@RestController
public class AppController {
    @Autowired
    StudentRepository studentRepository;
    @Autowired
    CourseRepository courseRepository;
    @Autowired
    TelephoneRepository telephoneRepository;
    @PostMapping("/insertStudent")
    public Student insertStudent(@RequestBody Student student){
        return studentRepository.save(student);
    }
    @PostMapping("/insertCourse")
    public Course insertCourse(@RequestBody Course course){
        return courseRepository.save(course);
    }
    @PostMapping("/insertTelephone")
    public Telephone insertTelephone(@RequestBody Telephone telephone){
        return telephoneRepository.save(telephone);
    }
    @GetMapping("/showStudents")
    public List<Student> showStudents(){
        return studentRepository.findAll();
    }
    @PutMapping("/addCourseToStudentId/{studentId}")
    public Student addCourseToStudentId(@PathVariable String studentId,@RequestParam String courseId){
        Optional<Course> course = courseRepository.findById(courseId);
        Optional<Student> student = studentRepository.findById(studentId);
        if (student.isPresent() && course.isPresent()){
            student.get().getCourses().add(course.get());
            return studentRepository.save(student.get());
        }
        return null;
    }
    @PutMapping("/addTelephoneToStudentId/{studentId}")
    public Student addTelephoneToStudentId(@PathVariable String studentId,@RequestParam Integer telephoneId){
        Optional<Telephone> telephone = telephoneRepository.findById(telephoneId);
        Optional<Student> student = studentRepository.findById(studentId);
        if (student.isPresent() && telephone.isPresent()){
            student.get().getTelephones().add(telephone.get());

            return studentRepository.save(student.get());
        }
        return null;
    }
}
